import java.util.concurrent.TimeUnit;
import java.io.IOException;

public class Sleep {
    public static void main(String[] args) throws InterruptedException, IOException {

	// Print kern.hz
	System.out.println();
	new ProcessBuilder("sysctl", "kern.hz").inheritIO().start().waitFor();
	System.out.println();

	// Tests.

	long t0;

	t0 = System.currentTimeMillis();

	for (int i = 1; i <= 1000; i++) {
	    Thread.sleep(1);
	}

	report(t0, "1000 times Thread.sleep(1)");

	t0 = System.currentTimeMillis();

	for (int i = 1; i <= 1000; i++) {
	    Thread.sleep(2);
	}

	report(t0, "1000 times Thread.sleep(2)");

	t0 = System.currentTimeMillis();

        for (int i = 1; i <= 1000; i++) {
            TimeUnit.MICROSECONDS.sleep(100);
        }

	report(t0, "1000 times TimeUnit.MICROSECONDS.sleep(100)");
    }

    private static void report(long t0, String what) {
	long elapsed = System.currentTimeMillis() - t0;
	System.out.println(String.format("%-48s  %8d milliseconds", what, elapsed));
    }
}
